#include <libopencm3/stm32/rcc.h>
#include <libopencm3/stm32/flash.h>
#include "stmf1rcc.h"
/* Good values:
   0x40021000:  0x03035883  0x001dc40a
   0x40021000:  0x03035883  0x001cc40a
*/
void
clock_hse8(void) {
    /* Activate HSE */
    rcc->cr |= RCC_CR_HSEON;
    while ((rcc->cr & RCC_CR_HSERDY) == 0)
        ;
    /* ATM no symbolic constant for mask */
    rcc->cfgr = (rcc->cfgr & ~0x3) | 1 /* RCC_CFGR_SW_HSE */;
#if 0
    rcc->cfgr = (rcc->cfgr &
                 ~((RCC_CFGR_HPRE_MASK<<RCC_CFGR_HPRE_SHIFT)
                   |(RCC_CFGR_PPRE2_MASK<<RCC_CFGR_PPRE2_SHIFT)
                   |(RCC_CFGR_PPRE1_MASK<<RCC_CFGR_PPRE1_SHIFT)))
                | (RCC_CFGR_HPRE_NODIV<<RCC_CFGR_HPRE_SHIFT) 
                | (RCC_CFGR_PPRE_NODIV<<RCC_CFGR_PPRE2_SHIFT)
                | (RCC_CFGR_PPRE_DIV_2<<RCC_CFGR_PPRE1_SHIFT);
#else
    rcc->cfgr = (rcc->cfgr & ~(RCC_CFGR_HPRE|RCC_CFGR_PPRE2|RCC_CFGR_PPRE1))
                | 0 /* (RCC_CFGR_HPRE_NODIV<<RCC_CFGR_HPRE_SHIFT) */
                | 0 /* (RCC_CFGR_PPRE_NODIV<<RCC_CFGR_PPRE2_SHIFT) */
                | (RCC_CFGR_PPRE1_HCLK_NODIV<<RCC_CFGR_PPRE1_SHIFT);
#endif
    while ((rcc->cfgr & (0x3<<RCC_CFGR_SWS_SHIFT))
            != (1 /* RCC_CFGR_SWS_HSE */ <<RCC_CFGR_SWS_SHIFT))
        ;
    /* No symbolic mask for latency */
    FLASH_ACR = (FLASH_ACR & ~0x7)
                | FLASH_ACR_LATENCY_0WS | 0 /* (1<<4) */ /* FLASH_ACR_PRFTEN */;
    /* Switch off PLL (do not need it). */
    rcc->cr &= ~(RCC_CR_PLL3ON|RCC_CR_PLL2ON | RCC_CR_PLLON);
}
